package xamora.gp_dbc.gui.CriminalTracker;

import xamora.gp_dbc.Main;
import xamora.gp_dbc.config.ConfigManager;
import xamora.gp_dbc.system.Criminal;
import xamora.gp_dbc.utils.Pos;
import xamora.gp_dbc.utils.TimeUtils;
import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.GuiButton;
import net.minecraft.item.ItemStack;
import net.minecraft.util.ResourceLocation;
import org.lwjgl.opengl.GL11;
import xamora.gp_dbc.utils.DrawGui;

import static xamora.gp_dbc.gui.CriminalTracker.GuiCriminalTracker.*;

public class GuiButtonCriminalTracker extends GuiButton {

    private static final ResourceLocation buttonTexturesNinjin = new ResourceLocation(Main.MODID, "textures/gui/criminalTracker.png");
    ItemStack stack;

    public GuiButtonCriminalTracker(int buttonId, int x, int y, int width, int height)
    {
        super(buttonId, x, y, "");
        this.enabled = true;
        this.visible = true;
        this.id = buttonId;
        this.xPosition = x;
        this.yPosition = y;
        this.origin_yPosition = y;
        this.width = width;
        this.height = height;
    }

    private int last_scroll_y;
    private int origin_yPosition;

    /**
     * Draws this button to the screen.
     **/
    @Override
    public void drawButton(Minecraft mc, int x, int y) {
        if (!this.visible)
            return;

        mc.getTextureManager().bindTexture(buttonTexturesNinjin);

        boolean flag = x >= xPosition && y >= yPosition && x < xPosition + this.width && y < yPosition + this.height;
        if (id < 0) { // criminals

            if (last_scroll_y != scroll_y) {
                last_scroll_y = scroll_y;
                yPosition = origin_yPosition + scroll_y;
            }

            int displayWidth = mc.displayWidth;
            int displayHeight = mc.displayHeight;

            int ratioWidth = (int) Math.round((double) displayWidth / wdth);
            int ratioHeight = (int) Math.round((double) displayHeight / hght);

            int newWidth = guiWidth * ratioWidth;
            int newHeight = guiHeight * ratioHeight;

            int displayGuiX = (int) Math.round((double) (displayWidth - newWidth) / 2);
            int displayGuiY = (int) Math.round((double) (displayHeight - newHeight) / 2);

            Criminal criminal = criminals.get(-(id) - 1);

            GL11.glPushMatrix();
            GL11.glScissor(displayGuiX , displayGuiY + 7 * ratioHeight, newWidth, (int) (newHeight - 27 * ratioHeight));
            GL11.glEnable(GL11.GL_SCISSOR_TEST);

            Pos pos = criminal.getLastPos();

            long rate = criminal.getRate();
            int ratio = (int)((double)rate / ConfigManager.MAX_RATE_CRIMINAL * 255);
            int color = (0xff << 24) | (Math.min(ratio * 10, 255) << 16) | (Math.max(255 - ratio * 3, 0) << 8) | 0x00;
            drawRect(xPosition, yPosition, xPosition + width, yPosition + height, color);

            DrawGui.drawLimited(mc.fontRenderer, criminal.getName(), xPosition + 1, yPosition + 1, width - 1, 8, 0xff000000);
            if (pos == null) {
                DrawGui.drawLimited(mc.fontRenderer, "No Position", xPosition + 1, yPosition + 14, width - 1, 6, 0xff000000);
                DrawGui.drawLimitedMin(mc.fontRenderer, "rate: " + rate, xPosition + 1, yPosition + 21, width - 1, 5, 0.55, 0.8, 0xff000000);
            }
            else {
                DrawGui.drawLimitedMin(mc.fontRenderer, "x:" + pos.x, xPosition + 1, yPosition + 9, width - 1, 5, 0.6, 0.8, 0xff000000);
                DrawGui.drawLimitedMin(mc.fontRenderer, "y:" + pos.y, xPosition + 1, yPosition + 14, width - 4, 5,0.6, 0.8, 0xff000000);
                DrawGui.drawLimitedMin(mc.fontRenderer, "z:" + pos.z, xPosition + 1, yPosition + 19, width - 1, 5,0.6, 0.8, 0xff000000);
                DrawGui.drawLimited(mc.fontRenderer, pos.dimension_name, xPosition + 1, yPosition + 24, width - 1, 5, 0xff000000);

                boolean flag_last_time_pos = x >= xPosition + 1 && y >= yPosition + 29 && x < xPosition + 1 + this.width - 1 && y < yPosition + 29 + 5;
                DrawGui.drawLimited(mc.fontRenderer, TimeUtils.getTimeDays((System.currentTimeMillis() - criminal.getLastPosTime()) / 1000L), xPosition + 1, yPosition + 29, width - 1, 5, 0xff000000);

                if (flag_last_time_pos) {
                    drawRect(x, y, x + width, y - 7, 0xf0ffffff);
                    DrawGui.drawLimited(mc.fontRenderer, "last time position", x + 1, y - 6, width - 1, 5, 0xff000000);
                }

                DrawGui.drawLimitedMin(mc.fontRenderer, "rate: " + rate, xPosition + 1, yPosition + 35, width - 1, 5, 0.55, 0.8, 0xff000000);
            }

            //drawRect(0, 0, displayWidth, displayHeight, 0x50ffffff);
            GL11.glDisable(GL11.GL_SCISSOR_TEST);
            GL11.glPopMatrix();
        }
        else if (id == 0) { // refresh
            if (flag) {
                GL11.glPushMatrix();
                GL11.glEnable(GL11.GL_BLEND);
                GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
                GL11.glColor4d(1, 1, 1, 0.3);
                GL11.glTranslated(this.xPosition - 0.25,  this.yPosition - 0.25, 0);
                GL11.glScaled(1.05, 1.05, 1.);
                this.drawTexturedModalRect(0, 0, 142, 0, this.width, this.height);
                GL11.glPopMatrix();
            }
            GL11.glPushMatrix();
            GL11.glColor4d(1, 1, 1, 1);
            GL11.glTranslated(0,  0, 1);
            this.drawTexturedModalRect(this.xPosition, this.yPosition, 142, 0, this.width, this.height);
            GL11.glPopMatrix();
        }
    }
}