package xamora.gp_dbc.gui.CriminalTracker;

import xamora.gp_dbc.Main;
import xamora.gp_dbc.system.Criminal;
import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.GuiButton;
import net.minecraft.client.gui.GuiScreen;
import net.minecraft.util.ChatComponentText;
import net.minecraft.util.EnumChatFormatting;
import net.minecraft.util.ResourceLocation;
import org.lwjgl.input.Mouse;
import org.lwjgl.opengl.GL11;

import java.util.List;

public class GuiCriminalTracker extends GuiScreen {

    final static int guiWidth = 280 / 2 + 1;
    final static int guiHeight = 240 / 2 + 1;

    public static int scroll_y = 0;

    public static int wdth;
    public static int hght;

    public static List<Criminal> criminals;
    int gap_y = 1;
    int number_by_line = 4;
    int criminal_width = 58 / 2;
    int criminal_height = 40;

    private GuiButtonCriminalTracker refresh_criminal;

    public GuiCriminalTracker(List<Criminal> criminals) {
        GuiCriminalTracker.criminals = criminals;
        scroll_y = 0;
    }

    @Override
    public void drawScreen(int mouse_x, int mouse_y, float ticks) {

        GL11.glColor4f(1, 1, 1, 1);

        int guiX = (width - guiWidth) / 2;
        int guiY = (height - guiHeight) / 2;

        drawDefaultBackground();

        mc.renderEngine.bindTexture(new ResourceLocation(Main.MODID, "textures/gui/criminalTracker.png"));

        // Texture
        GL11.glPushMatrix();
        GL11.glEnable(GL11.GL_BLEND);
        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
        //GL11.glColor4d(0.1, 0.6, 0.96, 0.95);
        //GL11.glTranslated(0,0, 1);
        drawTexturedModalRect(guiX, guiY, 0, 0, guiWidth, guiHeight);
        GL11.glPopMatrix();

        if (criminals.size() > 8) {

            GL11.glPushMatrix();
            GL11.glEnable(GL11.GL_BLEND);
            GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
            GL11.glTranslated(0,0, 1);
            int scrollbar_x = guiX + 130;
            int all_criminals = criminals.size() * (criminal_height + gap_y * number_by_line);
            int criminals_visible = 8 * (criminal_height + gap_y);
            int scrollable_criminals = all_criminals - criminals_visible;
            int max_height = 122;
            int scrollbar_add = -((scroll_y * max_height) / scrollable_criminals);
            int scrollbar_y = (int) (guiY + 20 + scrollbar_add); // 98 - 163
            drawRect(scrollbar_x, scrollbar_y, scrollbar_x + 6, scrollbar_y + 6, 0xff000000);

            GL11.glPopMatrix();
        }


        super.drawScreen(mouse_x, mouse_y, ticks);
    }

    @Override
    public void initGui() {

        if (criminals == null) {
            Minecraft.getMinecraft().displayGuiScreen(null);
            Minecraft.getMinecraft().thePlayer.addChatComponentMessage(new ChatComponentText(EnumChatFormatting.RED + "Error null criminals"));
            return;
        }

        wdth = width;
        hght = height;

        int guiX = (width - guiWidth) / 2;
        int guiY = (height - guiHeight) / 2;

        buttonList.clear();

        for (int i = 0 ; i < criminals.size(); i++) {
            int pos_x = guiX + 8 + (i % 4) * (criminal_width + 1);
            int pos_y = guiY + 20 + (i / 4) * (criminal_height + gap_y);
            buttonList.add(new GuiButtonCriminalTracker(-(i + 1), pos_x, pos_y, criminal_width, criminal_height));
        }

        buttonList.add(refresh_criminal = new GuiButtonCriminalTracker(0, guiX + 6, guiY + 5, 11, 11));

        //buttonList.add(buttonClose = new CyborgSoftwareGuiButton(1, guiX + 4, guiY - 3, 7, 7));


        super.initGui();
    }

    @Override
    protected void actionPerformed(GuiButton button) {
        if (button.id < 0) {

        }
        super.actionPerformed(button);
    }

    @Override
    protected void mouseClicked(int x, int y, int btn) {
        super.mouseClicked(x, y, btn);
    }

    @Override
    public void handleMouseInput() {
        super.handleMouseInput();

        if (criminals.size() <= 8)
            return;

        int dWheel = Mouse.getEventDWheel();

        //System.out.println(dWheel);
        if (dWheel != 0) {
            if (dWheel > 0) {
                scroll_y += 6;
                scroll_y = Math.min(1, scroll_y);
                //System.out.println("Molette vers le haut");
            } else {
                scroll_y -= 6;
                scroll_y = Math.max(-((criminals.size() - 8) * (criminal_height + gap_y)), scroll_y);
                //System.out.println("Molette vers le bas");
            }
        }
    }

    @Override
    public void updateScreen() {
        super.updateScreen();
    }
}