package xamora.gp_dbc.gui.JailManager;

import xamora.gp_dbc.Main;
import xamora.gp_dbc.network.server.NetworkJailManager;
import xamora.gp_dbc.proxy.CommonProxy;
import xamora.gp_dbc.system.Cell;
import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.GuiButton;
import net.minecraft.client.gui.GuiScreen;
import net.minecraft.util.ChatComponentText;
import net.minecraft.util.EnumChatFormatting;
import net.minecraft.util.ResourceLocation;
import org.lwjgl.input.Mouse;
import org.lwjgl.opengl.GL11;

import java.util.List;

public class GuiJailManager extends GuiScreen {

    final static int guiWidth = 212 / 2 + 1;
    final static int guiHeight = 320 / 2 + 1;

    public static int scroll_y = 0;

    public static int wdth;
    public static int hght;

    public static List<Cell> cells;
    int gap_y = 1;
    int cell_width = 76;
    int cell_height = 10;

    public static int cell_selected = -1; // ID of cell
    //private List<GuiButtonJailManager> cells_buttons = new ArrayList<>();
    private GuiButtonJailManager delete_cell;
    private GuiButtonJailManager edit_cell;

    public GuiJailManager(List<Cell> cells) {
        GuiJailManager.cells = cells;
        cell_selected = -1;
        scroll_y = 0;
    }

    @Override
    public void drawScreen(int mouse_x, int mouse_y, float ticks) {

        GL11.glColor4f(1, 1, 1, 1);

        int guiX = (width - guiWidth) / 2;
        int guiY = (height - guiHeight) / 2;

        drawDefaultBackground();

        mc.renderEngine.bindTexture(new ResourceLocation(Main.MODID, "textures/gui/jailManager.png"));

        // Texture
        GL11.glPushMatrix();
        GL11.glEnable(GL11.GL_BLEND);
        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
        //GL11.glColor4d(0.1, 0.6, 0.96, 0.95);
        //GL11.glTranslated(0,0, 1);
        drawTexturedModalRect(guiX, guiY - 10, 0, 0, guiWidth, guiHeight);
        GL11.glPopMatrix();

        if (cells.size() > 6) {
            int scrollbar_x = guiX + 90;
            int all_cells = cells.size() * (cell_height + gap_y);
            int cells_visible = 6 * (cell_height + gap_y);
            int scrollable_cells = all_cells - cells_visible;
            int max_height = 66;
            int scrollbar_add = -((scroll_y * max_height) / scrollable_cells);
            int scrollbar_y = (int) (guiY + 42 + scrollbar_add); // 98 - 163
            drawRect(scrollbar_x, scrollbar_y, scrollbar_x + 6, scrollbar_y + 6, 0xff000000);
        }


        super.drawScreen(mouse_x, mouse_y, ticks);
    }

    @Override
    public void initGui() {

        if (cells == null) {
            Minecraft.getMinecraft().displayGuiScreen(null);
            Minecraft.getMinecraft().thePlayer.addChatComponentMessage(new ChatComponentText(EnumChatFormatting.RED + "Error null cells"));
            return;
        }

        wdth = width;
        hght = height;

        int guiX = (width - guiWidth) / 2;
        int guiY = (height - guiHeight) / 2;

        buttonList.clear();

        for (int i = 0 ; i < cells.size(); i++) {
            int pos_x = guiX + 13;
            int pos_y = guiY + 37 + (i * (cell_height + gap_y)) ;
            buttonList.add(new GuiButtonJailManager(-(i + 1), pos_x, pos_y, cell_width, cell_height));
        }

        buttonList.add(edit_cell = new GuiButtonJailManager(0, guiX + 20, guiY + 115, 21, 21));
        buttonList.add(delete_cell = new GuiButtonJailManager(1, guiX + 65, guiY + 115, 21, 21 ));

        //buttonList.add(buttonClose = new CyborgSoftwareGuiButton(1, guiX + 4, guiY - 3, 7, 7));


        super.initGui();
    }

    @Override
    protected void actionPerformed(GuiButton button) {
        if (button.id < 0) {
            Cell cell = cells.get(-(button.id) - 1);

            if (cell_selected == cell.getId())
                cell_selected = -1;
            else
                cell_selected = cell.getId();
        }
        else if (button.id == 0) { // Edit

        }
        else if (button.id == 1) { // Delete
            if (cell_selected == -1)
                return;

            CommonProxy.network.sendToServer(new NetworkJailManager("delete~" + cell_selected));
        }
        super.actionPerformed(button);
    }

    @Override
    protected void mouseClicked(int x, int y, int btn) {
        super.mouseClicked(x, y, btn);
    }

    @Override
    public void handleMouseInput() {
        super.handleMouseInput();

        if (cells.size() <= 6)
            return;

        int dWheel = Mouse.getEventDWheel();

        //System.out.println(dWheel);
        if (dWheel != 0) {
            if (dWheel > 0) {
                scroll_y += 5;
                scroll_y = Math.min(1, scroll_y);
                //System.out.println("Molette vers le haut");
            } else {
                scroll_y -= 5;
                scroll_y = Math.max(-((cells.size() - 6) * (cell_height)), scroll_y);
                //System.out.println("Molette vers le bas");
            }
        }
    }

    @Override
    public void updateScreen() {
        super.updateScreen();
    }
}