package xamora.gp_dbc.items;

import cpw.mods.fml.common.registry.GameRegistry;
import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;
import xamora.gp_dbc.Main;
import xamora.gp_dbc.network.client.NetworkCriminalTrackerC;
import xamora.gp_dbc.proxy.CommonProxy;
import xamora.gp_dbc.system.Criminal;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.world.World;

import java.util.List;

public class ItemCriminalTracker extends Item {

    public ItemCriminalTracker()
    {
        super();
        setUnlocalizedName(Main.MODID +".criminal_tracker");
        GameRegistry.registerItem(this, getUnlocalizedName());
        setCreativeTab(Main.tabGP);
        setTextureName(Main.MODID + ":criminal_tracker");
        setMaxStackSize(1);
    }

    @Override
    @SideOnly(Side.SERVER)
    public ItemStack onItemRightClick(ItemStack itemStack, World world, EntityPlayer player) {

        boolean isCops = Main.gp.isInGalacticPatrol(player);

        String criminals = "";
        for (Criminal criminal : Main.gp.criminals.criminals) {
            Main.gp.criminals.getUpdatePos(criminal.getUuid());
            if (isCops)
                criminals += criminal.toString() + "#";
            else
                criminals += criminal.toStringWithoutPos() + "#";
        }

        CommonProxy.network.sendTo(new NetworkCriminalTrackerC("open~" + criminals), (EntityPlayerMP) player);

        return itemStack;
    }

    @SideOnly(Side.CLIENT)
    public void addInformation(ItemStack par1ItemStack, EntityPlayer par2EntityPlayer, List par3List, boolean par4) {
        par3List.add("Right Click to see criminals");
    }
}