package xamora.gp_dbc.network.client;

import cpw.mods.fml.common.network.ByteBufUtils;
import cpw.mods.fml.common.network.simpleimpl.IMessage;
import cpw.mods.fml.common.network.simpleimpl.IMessageHandler;
import cpw.mods.fml.common.network.simpleimpl.MessageContext;
import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;
import io.netty.buffer.ByteBuf;
import net.minecraft.client.Minecraft;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;

import static xamora.gp_dbc.utils.PlayerUtils.*;

public class NetworkDeleteItemC implements IMessage {

    private String toSend;

    public NetworkDeleteItemC() {
    }

    public NetworkDeleteItemC(String toSend) {
        this.toSend = toSend;
    }

    @Override
    public void toBytes(ByteBuf buf) {
        ByteBufUtils.writeUTF8String(buf, toSend);
    }

    @Override
    public void fromBytes(ByteBuf buf) {
        toSend = ByteBufUtils.readUTF8String(buf);
    }

    public static class MyMessageHandlerC implements
            IMessageHandler<NetworkDeleteItemC, IMessage> {

        @SideOnly(Side.CLIENT)
        @Override
        public IMessage onMessage(NetworkDeleteItemC message,
                                  MessageContext ctx) {

            String[] split = message.toSend.split("~");
            //String key = split[0];
            String item_name = split[0];

            EntityPlayer player = Minecraft.getMinecraft().thePlayer;
            ItemStack current_stack = player.getHeldItem();
            if (!current_stack.getDisplayName().equals(item_name))
                return null;

            int number = 1;

            try {
                number = Integer.parseInt(split[1]);
            } catch (Exception e) {
                return null;
            }

            removeCurrentItem(number);
            return null;
        }
    }
}
