package xamora.gp_dbc.network.client;

import cpw.mods.fml.common.network.ByteBufUtils;
import cpw.mods.fml.common.network.simpleimpl.IMessage;
import cpw.mods.fml.common.network.simpleimpl.IMessageHandler;
import cpw.mods.fml.common.network.simpleimpl.MessageContext;
import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;
import xamora.gp_dbc.gui.JailManager.GuiJailManager;
import xamora.gp_dbc.system.Cell;
import xamora.gp_dbc.system.Inmate;
import io.netty.buffer.ByteBuf;
import net.minecraft.client.Minecraft;

import java.util.ArrayList;
import java.util.List;
import java.util.UUID;

public class NetworkJailManagerC implements IMessage {

    private String toSend;

    public NetworkJailManagerC() {
    }

    public NetworkJailManagerC(String toSend) {
        this.toSend = toSend;
    }

    @Override
    public void toBytes(ByteBuf buf) {
        ByteBufUtils.writeUTF8String(buf, toSend);
    }

    @Override
    public void fromBytes(ByteBuf buf) {
        toSend = ByteBufUtils.readUTF8String(buf);
    }

    public static class MyMessageHandlerC implements
            IMessageHandler<NetworkJailManagerC, IMessage> {

        @SideOnly(Side.CLIENT)
        @Override
        public IMessage onMessage(NetworkJailManagerC message,
                                  MessageContext ctx) {

            String[] split = message.toSend.split("~");
            String key = split[0];

            if (key.equals("open") || key.equals("refresh")) {

                List<Cell> cells = new ArrayList<>();

                if (split.length > 1) {
                    String content = split[1];

                    try {
                        String[] cells_string = content.split("#");
                        for (String cell_string : cells_string) {
                            String[] info_cell = cell_string.split("\\$");
                            String[] pos = info_cell[0].split("@");
                            int place = Integer.parseInt(info_cell[1]);
                            int id = Integer.parseInt(info_cell[2]);

                            int x = Integer.parseInt(pos[0]);
                            int y = Integer.parseInt(pos[1]);
                            int z = Integer.parseInt(pos[2]);
                            int dimension = Integer.parseInt(pos[3]);

                            Cell cell = new Cell(x, y, z, dimension, place, id);

                            if (info_cell.length > 3) {
                                String[] inmates_string = info_cell[3].split("&");
                                for (String inmate_string : inmates_string) {
                                    String[] info_inmate = inmate_string.split("\\$");

                                    long sec_in_jail = Long.parseLong(info_inmate[0]);
                                    long time_start_jail = Long.parseLong(info_inmate[1]);

                                    UUID uuid = UUID.fromString(info_inmate[2]);

                                    new Inmate(cell, uuid, sec_in_jail, time_start_jail);
                                }
                            }
                            cells.add(cell);
                        }
                    } catch (Exception e) {
                        System.out.println(e);
                    }
                }

                Minecraft.getMinecraft().displayGuiScreen(new GuiJailManager(cells));
            }

            return null;
        }
    }
}
