package xamora.gp_dbc.network.server;

import cpw.mods.fml.common.network.ByteBufUtils;
import cpw.mods.fml.common.network.simpleimpl.IMessage;
import cpw.mods.fml.common.network.simpleimpl.IMessageHandler;
import cpw.mods.fml.common.network.simpleimpl.MessageContext;
import xamora.gp_dbc.network.client.NetworkJailManagerC;
import xamora.gp_dbc.proxy.CommonProxy;
import xamora.gp_dbc.system.Cell;
import xamora.gp_dbc.utils.PlayerUtils;
import io.netty.buffer.ByteBuf;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.util.ChatComponentText;
import net.minecraft.util.EnumChatFormatting;

import static xamora.gp_dbc.Main.gp;
import static xamora.gp_dbc.config.ConfigManager.*;

public class NetworkJailManager implements IMessage {

    private String toSend;

    public NetworkJailManager() {}

    public NetworkJailManager(String toSend) {
        this.toSend = toSend;
    }

    @Override
    public void toBytes(ByteBuf buf) {
        ByteBufUtils.writeUTF8String(buf,toSend);
    }

    @Override
    public void fromBytes(ByteBuf buf) {
        toSend = ByteBufUtils.readUTF8String(buf);
    }

    public static class MyMessageHandler implements
            IMessageHandler<NetworkJailManager, IMessage> {

        @Override
        public IMessage onMessage(NetworkJailManager message,
                                  MessageContext ctx) {

            EntityPlayerMP player = ctx.getServerHandler().playerEntity;
            if (OP_JAIL_MANAGER && !PlayerUtils.isOP(player))
                return null;

            String[] split = message.toSend.split("~");
            String key = split[0];

            if (key.equals("delete")) {

                try {
                    int id_cell = Integer.parseInt(split[1]);
                    gp.jail.removeCell(id_cell);

                    String cells = "";
                    for (Cell cell : gp.jail.getCells())
                        cells += cell.toString() + "#";

                    CommonProxy.network.sendTo(new NetworkJailManagerC("refresh~" + cells), (EntityPlayerMP) player);
                } catch (Exception e) {
                    player.addChatMessage(new ChatComponentText(EnumChatFormatting.RED + "Error delete cell"));
                }

            }
            else if (key.equals("edit")) {

            }

            return null;
        }
    }
}
