package xamora.gp_dbc.system;

import JinRyuu.JRMCore.server.JGPlayerMP;
import cpw.mods.fml.common.eventhandler.SubscribeEvent;
import cpw.mods.fml.common.gameevent.PlayerEvent;
import cpw.mods.fml.common.gameevent.TickEvent;
import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;
import xamora.gp_dbc.Main;
import xamora.gp_dbc.network.client.NetworkHandcuffedC;
import xamora.gp_dbc.proxy.CommonProxy;
import xamora.gp_dbc.utils.InputUtils;
import xamora.gp_dbc.utils.PlayerUtils;
import xamora.gp_dbc.utils.TextUtils;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.ChatComponentText;
import net.minecraft.util.EnumChatFormatting;
import net.minecraftforge.event.entity.player.EntityInteractEvent;
import xamora.gp_dbc.config.ConfigManager;

import java.util.*;

import static xamora.gp_dbc.utils.PlayerUtils.*;
import static net.minecraft.util.StatCollector.translateToLocal;

public class Handcuff {

    // patrol~handcuffed|StartTimeHandcuffed
    @SideOnly(Side.SERVER)
    //public static HashMap<String, Long> handcuffed = new HashMap<>();
    public static List<Handcuffed> handcuffed = new ArrayList<>();

    //@SideOnly(Side.CLIENT)
    //public static HashMap<UUID, Long> playerAroundHandcuffed = new HashMap<>();

    @SideOnly(Side.SERVER)
    public static HashMap<UUID, List<Handcuffed>> playersAroundHandcuffed = new HashMap<>();

    int tick = 0;
    final int SLOWTICK_MAX = 20;//2000;

    @SideOnly(Side.SERVER)
    @SubscribeEvent
    public void checkTimeJailer(TickEvent.ServerTickEvent event) {
        if (handcuffed.isEmpty())
            return;

        if (tick >= SLOWTICK_MAX) {
            tick = 0;

            for (int i = 0; i < handcuffed.size(); i++) {
                Handcuffed hdfd = handcuffed.get(i);
                UUID uuid_patrol = hdfd.jailer;
                UUID uuid_inmate = hdfd.inmate;
                long time_start = hdfd.start_time;
                long time_left = (time_start + (ConfigManager.TIME_TO_GO_IN_JAIL * 1000L) - System.currentTimeMillis()) / 1000;

                EntityPlayer inmate = getPlayerFromUUID(uuid_inmate);
                if (inmate != null)
                    updateHandcuffedPlayersAround(inmate);

                if (time_left > 0 || getUnhandcuffing(inmate) != null)
                    continue;

                if (inmate != null) {
                    if (!isHandcuffed(inmate))
                        continue;

                    CommonProxy.network.sendTo(new NetworkHandcuffedC("end~"), (EntityPlayerMP) inmate);

                    removeHandcuffed(inmate);
                    i--;

                    EntityPlayer patrol = getPlayerFromUUID(uuid_patrol);
                    Main.gp.jail.putPlayerInJail(patrol, inmate, Main.gp.criminals.getCriminal(inmate.getUniqueID()));
                }
                else
                    hdfd.start_time = -1L;

            }
        }
        else
            tick++;
    }

    // Update les autres joueurs sur le fait qu'ils soient menottés ou non
    @SideOnly(Side.SERVER)
    public static void updateHandcuffedPlayersAround(EntityPlayer inmate) {

        if (!isHandcuffed(inmate)) {
            if (playersAroundHandcuffed.containsKey(inmate.getUniqueID())) {
                playersAroundHandcuffed.remove(inmate.getUniqueID());
                List<EntityPlayer> nearbyPlayers = getNearbyPlayers(inmate, 10);
                for (EntityPlayer player : nearbyPlayers)
                    CommonProxy.network.sendTo(new NetworkHandcuffedC("delete~" + inmate.getUniqueID()), (EntityPlayerMP) player);
            }
            return;
        }

        UUID uuid_inmate = inmate.getUniqueID();
        List<Handcuffed> playerAroundHandcuffed = new ArrayList<>();
        List<Handcuffed> initPlayerAroundHandcuffed = null;
        if (playersAroundHandcuffed.containsKey(uuid_inmate)) // already handcuffed
            initPlayerAroundHandcuffed = playersAroundHandcuffed.get(uuid_inmate);


        boolean different = false;
        long time_start_handcuffed = getTimeHandcuffed(inmate);
        List<EntityPlayer> nearbyPlayers = getNearbyPlayers(inmate, 10);

        for (EntityPlayer player : nearbyPlayers) {
            UUID uuid_player = player.getUniqueID();
            playerAroundHandcuffed.add(new Handcuffed(uuid_player, time_start_handcuffed, getUnhandcuffing(inmate) != null));

            if (initPlayerAroundHandcuffed == null ||
                    !Handcuffed.contains_handcuffed(initPlayerAroundHandcuffed, uuid_player, time_start_handcuffed, getUnhandcuffing(inmate) != null)) {
                CommonProxy.network.sendTo(new NetworkHandcuffedC("update~" + inmate.getUniqueID() + "~" + time_start_handcuffed + "~" + ConfigManager.TIME_TO_GO_IN_JAIL + "~" + String.valueOf(getUnhandcuffing(inmate) != null)), (EntityPlayerMP) player);
                //System.out.println("update " + String.valueOf(getUnhandcuffing(inmate) != null) + " to " + player.getDisplayName());
                different = true;
            }
        }

        if (!different && !playerAroundHandcuffed.equals(initPlayerAroundHandcuffed))
            different = true;

        if (different)
            playersAroundHandcuffed.put(uuid_inmate, playerAroundHandcuffed);
    }

    @SubscribeEvent
    public void LogInCheckKOHandcuff(PlayerEvent.PlayerLoggedInEvent event) {
        EntityPlayer inmate = event.player;
        JGPlayerMP jgInmate = new JGPlayerMP(inmate);
        NBTTagCompound nbt = jgInmate.connectBaseNBT();
        if (getTimeHandcuffed(inmate) == -1) {
            nbt.setInteger("jrmcHar4va", 0);
            handcuffed.remove(getHandcuffed(inmate));
            CommonProxy.network.sendTo(new NetworkHandcuffedC("end~"), (EntityPlayerMP) inmate);
        }
    }

    @SideOnly(Side.SERVER)
    public static boolean putHandcuff(EntityPlayer jailer, EntityPlayer inmate) {
        /*if (handcuffeds.get(inmate.getUniqueID()) != null) {
            jailer.addChatMessage(new ChatComponentText(EnumChatFormatting.RED + ERROR_ALREADY_HANDCUFFED));
            return false;
        }*/
        long current_time = System.currentTimeMillis();

        handcuffed.add(new Handcuffed(inmate.getUniqueID(), jailer.getUniqueID(), current_time, false));
        jailer.addChatMessage(new ChatComponentText(EnumChatFormatting.GREEN + translateToLocal("success.you_handcuffed_him")));


        String[] texts = TextUtils.getSeparateText(translateToLocal("success.you_are_handcuffed"), "%%");
        inmate.addChatMessage(new ChatComponentText(EnumChatFormatting.RED + texts[0] + ConfigManager.TIME_TO_GO_IN_JAIL + texts[1]));

        JGPlayerMP jgInmate = new JGPlayerMP(inmate);
        NBTTagCompound nbt = jgInmate.connectBaseNBT();
        nbt.setInteger("jrmcHar4va", ConfigManager.TIME_TO_GO_IN_JAIL * 2);

        CommonProxy.network.sendTo(new NetworkHandcuffedC("start~" + current_time + "~" + ConfigManager.TIME_TO_GO_IN_JAIL), (EntityPlayerMP) inmate);
        updateHandcuffedPlayersAround(inmate);

        return true;
    }

    @SideOnly(Side.SERVER)
    public static Handcuffed getHandcuffed(EntityPlayer inmate) {
        for (Handcuffed hdfd : handcuffed) {
            if (hdfd.inmate.equals(inmate.getUniqueID()))
                return hdfd;
        }
        return null;
    }

    @SideOnly(Side.SERVER)
    public static long getTimeHandcuffed(EntityPlayer inmate) {
        Handcuffed hdfd = getHandcuffed(inmate);
        if (hdfd == null)
            return 0;
        return hdfd.start_time;
    }

    @SideOnly(Side.SERVER)
    public static boolean isHandcuffed(EntityPlayer inmate) {
        return getHandcuffed(inmate) != null;
    }

    @SideOnly(Side.SERVER)
    public static boolean removeHandcuffed(EntityPlayer inmate) {

        Handcuffed handcuff = getHandcuffed(inmate);
        if (handcuff == null)
            return false;

        handcuffed.remove(handcuff);
        JGPlayerMP jgInmate = new JGPlayerMP(inmate);
        NBTTagCompound nbt = jgInmate.connectBaseNBT();
        nbt.setInteger("jrmcHar4va", 0);
        inmate.addChatMessage(new ChatComponentText(EnumChatFormatting.GREEN + translateToLocal("success.you_are_free")));
        updateHandcuffedPlayersAround(inmate);

        return true;
    }

    // liberator~inmate|StartTimeUnhandcuffing
    @SideOnly(Side.SERVER)
    public static HashMap<String, Long> unhandcuffing = new HashMap<>();


    @SideOnly(Side.SERVER)
    public static String getUnhandcuffing(EntityPlayer inmate) {
        for (String uuids : unhandcuffing.keySet()) {
            String[] split = uuids.split("~");
            //System.out.println(Arrays.toString(split) + " " + split[1].equals(inmate.getUniqueID().toString()));
            if (split[1].equals(inmate.getUniqueID().toString()))
                return uuids;
        }
        return null;
    }


    @SideOnly(Side.SERVER)
    @SubscribeEvent
    public void RemoveHandcuff(EntityInteractEvent event) {
        if (event.target instanceof EntityPlayer) {
            EntityPlayer target = (EntityPlayer) event.target;
            EntityPlayer player = event.entityPlayer;

            if (isHandcuffed(target) && player.isSneaking() && getUnhandcuffing(target) == null) {
                player.addChatMessage(new ChatComponentText(EnumChatFormatting.YELLOW + translateToLocal("msg.unhandcuffing_someone")));
                target.addChatMessage(new ChatComponentText(EnumChatFormatting.YELLOW + translateToLocal("msg.unhandcuffing_you")));

                unhandcuffing.put(player.getUniqueID() + "~" + target.getUniqueID(), System.currentTimeMillis());
            }
        }
    }

    int tick2 = 0;

    @SideOnly(Side.SERVER)
    @SubscribeEvent
    public void checkAlwaysUnhandcuffing(TickEvent.ServerTickEvent event) {
        if (unhandcuffing.isEmpty())
            return;

        if (tick2 >= SLOWTICK_MAX) {
            tick2 = 0;

            Iterator<Map.Entry<String, Long>> iterator = unhandcuffing.entrySet().iterator();
            while (iterator.hasNext()) {
                Map.Entry<String, Long> entry = iterator.next();
                String[] split = entry.getKey().split("~");
                UUID liberator_uuid = UUID.fromString(split[0]);
                EntityPlayer liberator = PlayerUtils.getPlayerFromUUID(liberator_uuid);
                EntityPlayer inmate = PlayerUtils.getPlayerFromUUID(UUID.fromString(split[1]));
                if (liberator == null || inmate == null)
                    continue;

                if ((InputUtils.useItemPressedPlayers.containsKey(liberator_uuid) && !InputUtils.useItemPressedPlayers.get(liberator_uuid))
                        || !liberator.isSneaking()) {
                    iterator.remove();
                    liberator.addChatMessage(new ChatComponentText(EnumChatFormatting.YELLOW + translateToLocal("msg.stop_unhandcuffing_someone")));
                }
                else {
                    long start_time_unhandcuffing = entry.getValue();
                    long current_time = System.currentTimeMillis();

                    if (current_time - start_time_unhandcuffing > ConfigManager.TIME_UNHANDCUFFING * 1000L) {
                        removeHandcuffed(inmate);
                        iterator.remove();
                    }

                }

                updateHandcuffedPlayersAround(inmate);
            }
        }
        else
            tick2++;
    }

    @SideOnly(Side.SERVER)
    @SubscribeEvent
    public void checkPlayerIsHandcuffed(PlayerEvent.PlayerLoggedOutEvent event) {
        Handcuffed handcuffed = getHandcuffed(event.player);
        if (handcuffed == null)
            return;

        EntityPlayer patrol = PlayerUtils.getPlayerFromUUID(handcuffed.jailer);
        EntityPlayer inmate = event.player;

        removeHandcuffed(inmate);
        Main.gp.jail.putPlayerInJail(patrol, inmate, Main.gp.criminals.getCriminal(inmate.getUniqueID()));
    }
}
