package xamora.gp_dbc.utils;

import xamora.gp_dbc.config.ConfigManager;

import java.io.*;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.List;
import java.util.UUID;

public class Data {

    public static void saveDataUUID(List<UUID> list, String name) {
        List<String> new_list = new ArrayList<>();
        for (UUID uuid : list)
            new_list.add(uuid.toString());
        saveDataString(new_list, name);
    }

    public static void saveDataString(List<String> list, String name) {
        try {
            String path = ConfigManager.DIR_SAVE + name + ".txt";
            Files.createDirectories(Paths.get(ConfigManager.DIR_SAVE));
            File file = new File(path);
            file.delete();
            file.createNewFile();

            BufferedWriter bufferedWriter = new BufferedWriter(new FileWriter(path, true));

            for (int i = 0; i < list.size() - 2; i++)
                bufferedWriter.write(list.get(i) + "\n");
            if (list.size() > 0)
                bufferedWriter.write(list.get(list.size() - 1));

            bufferedWriter.close();

        } catch (IOException e) {
            System.out.println("An error occurred : " + e);
            e.printStackTrace();
        }
    }

    public static List<UUID> loadDataUUID(String name) {
        List<UUID> data = new ArrayList<>();
        List<String> strs = loadDataString(name);
        
        for (String s : strs)
            data.add(UUID.fromString(s));
        return data;
    }

    public static List<String> loadDataString(String name) {
        List<String> data = new ArrayList<>();

        try {
            String path = ConfigManager.DIR_SAVE + name + ".txt";
            BufferedReader br = new BufferedReader(new FileReader(new File(path)));

            String st;
            while ((st = br.readLine()) != null)
                data.add(st);

        } catch (IOException e) {
            System.out.println(e);
        }

        return data;
    }
}
