package xamora.gp_dbc.utils;

import net.minecraft.client.gui.FontRenderer;
import org.lwjgl.opengl.GL11;

public class DrawGui {
    public static void drawLimited(FontRenderer fontRenderer, String text, int x, int y, int width, int height, int color) {
        int size_x = fontRenderer.getStringWidth(text);
        int size_y = fontRenderer.FONT_HEIGHT;
        double scale_x = (double)width / (double)size_x;
        double scale_y = (double)height / (double)size_y;

        GL11.glPushMatrix();
        GL11.glScaled(scale_x, scale_y, 1.0);
        fontRenderer.drawString(text, (int) (Math.round(x / scale_x)), (int) (Math.round(y / scale_y)), color);
        GL11.glPopMatrix();
    }

    public static void drawLimitedMin(FontRenderer fontRenderer, String text, int x, int y, int width, int height, double min_x, double min_y, int color) {
        int size_x = fontRenderer.getStringWidth(text);
        int size_y = fontRenderer.FONT_HEIGHT;
        double scale_x = Math.min((double)width / (double)size_x, min_x);
        double scale_y = Math.min((double)height / (double)size_y, min_y);

        GL11.glPushMatrix();
        GL11.glScaled(scale_x, scale_y, 1.0);
        fontRenderer.drawString(text, (int) (Math.round(x / scale_x)), (int) (Math.round(y / scale_y)), color);
        GL11.glPopMatrix();
    }

    public static void drawLimitedShadow(FontRenderer fontRenderer, String text, int x, int y, int width, int height, int color) {
        int size_x = fontRenderer.getStringWidth(text);
        int size_y = fontRenderer.FONT_HEIGHT;
        double scale_x = (double)width / (double)size_x;
        double scale_y = (double)height / (double)size_y;

        GL11.glPushMatrix();
        GL11.glScaled(scale_x, scale_y, 1.0);
        fontRenderer.drawStringWithShadow(text, (int) (Math.round(x / scale_x)), (int) (Math.round(y / scale_y)), color);
        GL11.glPopMatrix();
    }
}
