package xamora.gp_dbc.utils;

import net.minecraft.entity.Entity;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.util.AxisAlignedBB;
import net.minecraft.util.MovingObjectPosition;
import net.minecraft.util.Vec3;
import net.minecraft.world.World;

import java.util.List;

public class EntityUtils {

        public static Entity getEntityLookedAt(Entity entity, double range) {
            World world = entity.worldObj;
            Entity pointedEntity = null;
            Vec3 vec3 = Vec3.createVectorHelper(entity.posX, entity.posY + entity.getEyeHeight(), entity.posZ);
            Vec3 vec31 = entity.getLookVec();
            Vec3 vec32 = vec3.addVector(vec31.xCoord * range, vec31.yCoord * range, vec31.zCoord * range);
            List<Entity> list = world.getEntitiesWithinAABBExcludingEntity(entity,
                    entity.boundingBox.addCoord(vec31.xCoord * range, vec31.yCoord * range, vec31.zCoord * range).expand(1.0D, 1.0D, 1.0D));
            double closestEntityDistance = range * range;

            for (Entity entityList : list) {
                if (entityList.canBeCollidedWith()) {
                    float collisionBorderSize = entityList.getCollisionBorderSize();
                    AxisAlignedBB axisalignedbb = entityList.boundingBox.expand((double) collisionBorderSize, (double) collisionBorderSize, (double) collisionBorderSize);
                    MovingObjectPosition movingobjectposition = axisalignedbb.calculateIntercept(vec3, vec32);

                    if (axisalignedbb.isVecInside(vec3)) {
                        if (closestEntityDistance >= 0.0D) {
                            pointedEntity = entityList;
                            closestEntityDistance = 0.0D;
                        }
                    } else if (movingobjectposition != null) {
                        double distanceToEntity = vec3.distanceTo(movingobjectposition.hitVec);

                        if (distanceToEntity < closestEntityDistance || closestEntityDistance == 0.0D) {
                            pointedEntity = entityList;
                            closestEntityDistance = distanceToEntity;
                        }
                    }
                }
            }

            return pointedEntity;
        }

    public static List<Entity> getNearbyEntities(EntityPlayer player, double radius) {
        World world = player.worldObj;
        AxisAlignedBB aabb = AxisAlignedBB.getBoundingBox(
                player.posX - radius, player.posY - radius, player.posZ - radius,
                player.posX + radius, player.posY + radius, player.posZ + radius
        );
        return world.getEntitiesWithinAABB(Entity.class, aabb);
    }

}
