package xamora.gp_dbc.utils;

import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;
import xamora.gp_dbc.network.client.NetworkDeleteItemC;
import xamora.gp_dbc.proxy.CommonProxy;
import net.minecraft.client.Minecraft;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.item.ItemStack;
import net.minecraft.server.MinecraftServer;
import net.minecraft.util.AxisAlignedBB;
import net.minecraft.world.World;

import java.util.List;
import java.util.UUID;

public class PlayerUtils {

    public static List<EntityPlayer> playerList;

    @SideOnly(Side.SERVER)
    public static EntityPlayer getPlayerFromUUID(UUID uuid) {

        playerList = MinecraftServer.getServer().getConfigurationManager().playerEntityList;
        for (EntityPlayer player : playerList) {
            if (player.getUniqueID().equals(uuid))
                return player;
        }

        return null;
    }

    @SideOnly(Side.SERVER)
    public static void removeCurrentItem(EntityPlayer player, int number) {
        ItemStack stack = player.getHeldItem();
        if (stack.stackSize > number)
            player.inventory.setInventorySlotContents(player.inventory.currentItem, new ItemStack(stack.getItem(), stack.stackSize - number));
        else
            player.inventory.setInventorySlotContents(player.inventory.currentItem, null);

        CommonProxy.network.sendTo(new NetworkDeleteItemC(stack.getDisplayName() + "~" + number), (EntityPlayerMP) player);
    }

    @SideOnly(Side.SERVER)
    public static boolean isOP(EntityPlayer player) {
        return MinecraftServer.getServer().getConfigurationManager().func_152596_g(player.getGameProfile());
    }

    public static List<EntityPlayer> getNearbyPlayers(EntityPlayer player, double radius) {
        World world = player.worldObj;
        AxisAlignedBB aabb = AxisAlignedBB.getBoundingBox(
                player.posX - radius, player.posY - radius, player.posZ - radius,
                player.posX + radius, player.posY + radius, player.posZ + radius
        );
        return world.getEntitiesWithinAABB(EntityPlayer.class, aabb);
    }

    @SideOnly(Side.CLIENT)
    public static void removeCurrentItem(int number) {
        EntityPlayer player = Minecraft.getMinecraft().thePlayer;
        ItemStack stack = player.getHeldItem();

        if (stack.stackSize > number)
            player.inventory.setInventorySlotContents(player.inventory.currentItem, new ItemStack(stack.getItem(), stack.stackSize - number));
        else
            player.inventory.setInventorySlotContents(player.inventory.currentItem, null);
    }
}
